/***************************************************************************
    File                 : WorksheetDecorationElement.cpp
    Project              : LabPlot/SciDAVis
    Description          : Base class for decoration elements.
    --------------------------------------------------------------------
    Copyright            : (C) 2009 Tilman Benkert (thzs*gmx.net)
                           (replace * with @ in the email addresses) 
                           
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *  This program is free software; you can redistribute it and/or modify   *
 *  it under the terms of the GNU General Public License as published by   *
 *  the Free Software Foundation; either version 2 of the License, or      *
 *  (at your option) any later version.                                    *
 *                                                                         *
 *  This program is distributed in the hope that it will be useful,        *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of         *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *  GNU General Public License for more details.                           *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the Free Software           *
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor,                    *
 *   Boston, MA  02110-1301  USA                                           *
 *                                                                         *
 ***************************************************************************/

#include "worksheet/AbstractWorksheetDecorationElement.h"

/**
 * \class WorksheetDecorationElement
 * \brief Base class for decoration elements.
 *
 * 
 */

/**
 * \fn void AbstractWorksheetDecorationElement::setXScale(qreal xScale, bool keepAspectRatio=false)
 * \brief Set the X scaling factor.
 *
 */

/**
 * \fn void AbstractWorksheetDecorationElement::setYScale(qreal yScale, bool keepAspectRatio=false)
 * \brief Set the Y scaling factor.
 *
 */
/**
 * \fn qreal AbstractWorksheetDecorationElement::xScale() const
 * \brief Return the X scaling factor.
 *
 */
/**
 * \fn qreal AbstractWorksheetDecorationElement::yScale() const
 * \brief Return the Y scaling factor.
 *
 */
/**
 * \fn void AbstractWorksheetDecorationElement::setRotationAngle(qreal angle)
 * \brief Set the rotation angle.
 *
 */
/**
 * \fn qreal AbstractWorksheetDecorationElement::rotationAngle() const
 * \brief Return the rotation angle.
 *
 */
/**
 * \fn void AbstractWorksheetDecorationElement::setPosition(const QPointF &position)
 * \brief Set the element's position.
 *
 */
/**
 * \fn QPointF AbstractWorksheetDecorationElement::position() const
 * \brief Return the element's position.
 *
 */
